748704437d726ccd77b41097d081a5c63088f195
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
27 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
28 CHECK_VERSION = $(top_srcdir)/autotools/check-version
29 CHECK_NEWS = $(top_srcdir)/autotools/check-news
30 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
31 DOCPP = $(top_srcdir)/autotools/docpp
32 REPLACE_VARS_SED = autotools/replace_vars.sed
33 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
34 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
35 SHELL_ENV_INIT = autotools/shell-env-init
36
37 # Note: these are automake-specific variables, and must be named after
38 # the directory + 'dir' suffix
39 clientdir = $(pkgpythondir)/client
40 hypervisordir = $(pkgpythondir)/hypervisor
41 httpdir = $(pkgpythondir)/http
42 masterddir = $(pkgpythondir)/masterd
43 confddir = $(pkgpythondir)/confd
44 rapidir = $(pkgpythondir)/rapi
45 serverdir = $(pkgpythondir)/server
46 watcherdir = $(pkgpythondir)/watcher
47 impexpddir = $(pkgpythondir)/impexpd
48 utilsdir = $(pkgpythondir)/utils
49 toolsdir = $(pkglibdir)/tools
50 iallocatorsdir = $(pkglibdir)/iallocators
51 pytoolsdir = $(pkgpythondir)/tools
52 docdir = $(datadir)/doc/$(PACKAGE)
53 myexeclibdir = $(pkglibdir)
54
55 # Delete output file if an error occurred while building it
56 .DELETE_ON_ERROR:
57
58 HS_DIRS = \
59         src \
60         src/Ganeti \
61         src/Ganeti/Block \
62         src/Ganeti/Block/Drbd \
63         src/Ganeti/Confd \
64         src/Ganeti/DataCollectors \
65         src/Ganeti/HTools \
66         src/Ganeti/HTools/Backend \
67         src/Ganeti/HTools/Program \
68         src/Ganeti/Query \
69         test/hs \
70         test/hs/Test \
71         test/hs/Test/Ganeti \
72         test/hs/Test/Ganeti/Block \
73         test/hs/Test/Ganeti/Block/Drbd \
74         test/hs/Test/Ganeti/Confd \
75         test/hs/Test/Ganeti/HTools \
76         test/hs/Test/Ganeti/HTools/Backend \
77         test/hs/Test/Ganeti/Query
78
79 DIRS = \
80         $(HS_DIRS) \
81         autotools \
82         daemons \
83         devel \
84         doc \
85         doc/css \
86         doc/examples \
87         doc/examples/gnt-debug \
88         doc/examples/hooks \
89         test/data/htools \
90         test/data/htools/rapi \
91         test/hs/shelltests \
92         lib \
93         lib/build \
94         lib/client \
95         lib/confd \
96         lib/http \
97         lib/hypervisor \
98         lib/impexpd \
99         lib/masterd \
100         lib/rapi \
101         lib/server \
102         lib/tools \
103         lib/utils \
104         lib/watcher \
105         man \
106         qa \
107         test \
108         test/data \
109         test/data/ovfdata \
110         test/data/ovfdata/other \
111         test/py \
112         tools
113
114 ALL_APIDOC_HS_DIRS = \
115         $(APIDOC_HS_DIR) \
116         $(APIDOC_HS_DIR)/Ganeti \
117         $(APIDOC_HS_DIR)/Ganeti/Block \
118         $(APIDOC_HS_DIR)/Ganeti/Block/Drbd \
119         $(APIDOC_HS_DIR)/Ganeti/Confd \
120         $(APIDOC_HS_DIR)/Ganeti/DataCollectors \
121         $(APIDOC_HS_DIR)/Ganeti/HTools \
122         $(APIDOC_HS_DIR)/Ganeti/HTools/Backend \
123         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
124         $(APIDOC_HS_DIR)/Ganeti/Query
125
126 BUILDTIME_DIR_AUTOCREATE = \
127         scripts \
128         $(APIDOC_DIR) \
129         $(ALL_APIDOC_HS_DIRS) \
130         $(APIDOC_PY_DIR) \
131         $(COVERAGE_DIR) \
132         $(COVERAGE_HS_DIR) \
133         $(COVERAGE_PY_DIR) \
134         .hpc
135
136 BUILDTIME_DIRS = \
137         $(BUILDTIME_DIR_AUTOCREATE) \
138         doc/html \
139         doc/man-html
140
141 DIRCHECK_EXCLUDE = \
142         $(BUILDTIME_DIRS) \
143         ganeti-[0-9]*.[0-9]*.[0-9]* \
144         doc/html/_* \
145         doc/man-html/_* \
146         autom4te.cache
147
148 # some helper vars
149 COVERAGE_DIR = doc/coverage
150 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
151 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
152 APIDOC_DIR = doc/api
153 APIDOC_PY_DIR = $(APIDOC_DIR)/py
154 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
155
156 MAINTAINERCLEANFILES = \
157         $(maninput) \
158         doc/install-quick.rst \
159         doc/news.rst \
160         doc/upgrade.rst \
161         vcs-version
162
163 maintainer-clean-local:
164         rm -rf $(BUILDTIME_DIRS)
165
166 CLEANFILES = \
167         $(addsuffix /*.py[co],$(DIRS)) \
168         $(addsuffix /*.hi,$(HS_DIRS)) \
169         $(addsuffix /*.o,$(HS_DIRS)) \
170         $(PYTHON_BOOTSTRAP) \
171         epydoc.conf \
172         $(REPLACE_VARS_SED) \
173         $(SHELL_ENV_INIT) \
174         daemons/daemon-util \
175         daemons/ganeti-cleaner \
176         $(mandocrst) \
177         doc/manpages-enabled.rst \
178         $(BUILT_EXAMPLES) \
179         doc/examples/bash_completion \
180         doc/examples/bash_completion-debug \
181         lib/_generated_rpc.py \
182         $(man_MANS) \
183         $(manhtml) \
184         tools/kvm-ifup \
185         tools/vcluster-setup \
186         stamp-directories \
187         stamp-srclinks \
188         $(nodist_pkgpython_PYTHON) \
189         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
190         $(HS_BUILT_TEST_HELPERS) \
191         src/ganeti-confd \
192         .hpc/*.mix src/*.tix test/hs/*.tix \
193         doc/hs-lint.html
194
195 GENERATED_FILES = \
196         $(built_base_sources) \
197         $(BUILT_PYTHON_SOURCES) \
198         $(PYTHON_BOOTSTRAP)
199
200 HS_GENERATED_FILES =
201 if WANT_HTOOLS
202 HS_GENERATED_FILES += $(HS_PROGS)
203 if ENABLE_CONFD
204 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
205 endif
206 endif
207
208 built_base_sources = \
209         stamp-directories \
210         stamp-srclinks
211
212 built_python_base_sources = \
213         lib/_autoconf.py \
214         lib/_vcsversion.py
215
216 BUILT_PYTHON_SOURCES = \
217         $(built_python_base_sources) \
218         lib/_generated_rpc.py
219
220 # Generating the RPC wrappers depends on many things, so make sure
221 # it's built at the end of the built sources
222 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
223
224 # these are all built from the underlying %.in sources
225 BUILT_EXAMPLES = \
226         doc/examples/ganeti-kvm-poweroff.initd \
227         doc/examples/ganeti.cron \
228         doc/examples/ganeti.initd \
229         doc/examples/ganeti-master-role.ocf \
230         doc/examples/ganeti-node-role.ocf \
231         doc/examples/gnt-config-backup \
232         doc/examples/hooks/ipsec
233
234 nodist_pkgpython_PYTHON = \
235         $(BUILT_PYTHON_SOURCES)
236
237 noinst_PYTHON = \
238         lib/build/__init__.py \
239         lib/build/shell_example_lexer.py \
240         lib/build/sphinx_ext.py
241
242 pkgpython_PYTHON = \
243         lib/__init__.py \
244         lib/asyncnotifier.py \
245         lib/backend.py \
246         lib/bdev.py \
247         lib/bootstrap.py \
248         lib/cli.py \
249         lib/cmdlib.py \
250         lib/compat.py \
251         lib/config.py \
252         lib/constants.py \
253         lib/daemon.py \
254         lib/errors.py \
255         lib/ht.py \
256         lib/jqueue.py \
257         lib/jstore.py \
258         lib/locking.py \
259         lib/luxi.py \
260         lib/mcpu.py \
261         lib/netutils.py \
262         lib/objects.py \
263         lib/objectutils.py \
264         lib/opcodes.py \
265         lib/ovf.py \
266         lib/pathutils.py \
267         lib/qlang.py \
268         lib/query.py \
269         lib/rpc.py \
270         lib/rpc_defs.py \
271         lib/runtime.py \
272         lib/serializer.py \
273         lib/ssconf.py \
274         lib/ssh.py \
275         lib/storage.py \
276         lib/uidpool.py \
277         lib/vcluster.py \
278         lib/network.py \
279         lib/workerpool.py
280
281 client_PYTHON = \
282         lib/client/__init__.py \
283         lib/client/gnt_backup.py \
284         lib/client/gnt_cluster.py \
285         lib/client/gnt_debug.py \
286         lib/client/gnt_group.py \
287         lib/client/gnt_instance.py \
288         lib/client/gnt_job.py \
289         lib/client/gnt_node.py \
290         lib/client/gnt_network.py \
291         lib/client/gnt_os.py \
292         lib/client/gnt_storage.py
293
294 hypervisor_PYTHON = \
295         lib/hypervisor/__init__.py \
296         lib/hypervisor/hv_base.py \
297         lib/hypervisor/hv_chroot.py \
298         lib/hypervisor/hv_fake.py \
299         lib/hypervisor/hv_kvm.py \
300         lib/hypervisor/hv_lxc.py \
301         lib/hypervisor/hv_xen.py
302
303 rapi_PYTHON = \
304         lib/rapi/__init__.py \
305         lib/rapi/baserlib.py \
306         lib/rapi/client.py \
307         lib/rapi/client_utils.py \
308         lib/rapi/connector.py \
309         lib/rapi/rlib2.py \
310         lib/rapi/testutils.py
311
312 http_PYTHON = \
313         lib/http/__init__.py \
314         lib/http/auth.py \
315         lib/http/client.py \
316         lib/http/server.py
317
318 confd_PYTHON = \
319         lib/confd/__init__.py \
320         lib/confd/client.py
321
322 masterd_PYTHON = \
323         lib/masterd/__init__.py \
324         lib/masterd/iallocator.py \
325         lib/masterd/instance.py
326
327 impexpd_PYTHON = \
328         lib/impexpd/__init__.py
329
330 watcher_PYTHON = \
331         lib/watcher/__init__.py \
332         lib/watcher/nodemaint.py \
333         lib/watcher/state.py
334
335 server_PYTHON = \
336         lib/server/__init__.py \
337         lib/server/masterd.py \
338         lib/server/noded.py \
339         lib/server/rapi.py
340
341 pytools_PYTHON = \
342         lib/tools/__init__.py \
343         lib/tools/burnin.py \
344         lib/tools/ensure_dirs.py \
345         lib/tools/node_cleanup.py \
346         lib/tools/node_daemon_setup.py \
347         lib/tools/prepare_node_join.py
348
349 utils_PYTHON = \
350         lib/utils/__init__.py \
351         lib/utils/algo.py \
352         lib/utils/filelock.py \
353         lib/utils/hash.py \
354         lib/utils/io.py \
355         lib/utils/log.py \
356         lib/utils/lvm.py \
357         lib/utils/mlock.py \
358         lib/utils/nodesetup.py \
359         lib/utils/process.py \
360         lib/utils/retry.py \
361         lib/utils/text.py \
362         lib/utils/wrapper.py \
363         lib/utils/x509.py
364
365 docinput = \
366         doc/conf.py \
367         doc/css/style.css \
368         doc/admin.rst \
369         doc/cluster-merge.rst \
370         doc/design-2.0.rst \
371         doc/design-2.1.rst \
372         doc/design-2.2.rst \
373         doc/design-2.3.rst \
374         doc/design-2.4.rst \
375         doc/design-2.5.rst \
376         doc/design-2.6.rst \
377         doc/design-2.7.rst \
378         doc/design-autorepair.rst \
379         doc/design-bulk-create.rst \
380         doc/design-chained-jobs.rst \
381         doc/design-cpu-pinning.rst \
382         doc/design-draft.rst \
383         doc/design-htools-2.3.rst \
384         doc/design-http-server.rst \
385         doc/design-impexp2.rst \
386         doc/design-lu-generated-jobs.rst \
387         doc/design-linuxha.rst \
388         doc/design-multi-reloc.rst \
389         doc/design-network.rst \
390         doc/design-node-add.rst \
391         doc/design-oob.rst \
392         doc/design-ovf-support.rst \
393         doc/design-opportunistic-locking.rst \
394         doc/design-partitioned.rst \
395         doc/design-query-splitting.rst \
396         doc/design-query2.rst \
397         doc/design-remote-commands.rst \
398         doc/design-resource-model.rst \
399         doc/design-shared-storage.rst \
400         doc/design-monitoring-agent.rst \
401         doc/design-virtual-clusters.rst \
402         doc/design-x509-ca.rst \
403         doc/devnotes.rst \
404         doc/glossary.rst \
405         doc/hooks.rst \
406         doc/iallocator.rst \
407         doc/index.rst \
408         doc/install-quick.rst \
409         doc/install.rst \
410         doc/locking.rst \
411         doc/manpages-disabled.rst \
412         doc/move-instance.rst \
413         doc/news.rst \
414         doc/ovfconverter.rst \
415         doc/rapi.rst \
416         doc/security.rst \
417         doc/upgrade.rst \
418         doc/virtual-cluster.rst \
419         doc/walkthrough.rst
420
421 # Generates file names such as "doc/man-gnt-instance.rst"
422 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
423
424 # Haskell programs to be installed in $PREFIX/bin
425 HS_BIN_PROGS=src/htools
426
427 # Haskell programs to be installed in the MYEXECLIB dir
428 HS_MYEXECLIB_PROGS=src/mon-collector
429
430 # Haskell programs to compiled but not installed automatically
431 # Usually they have their own specific installation rules
432 HS_COMPILE_PROGS= \
433         src/hconfd \
434         src/rpc-test
435
436 # All Haskell non-test programs to be compiled but not automatically installed
437 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
438
439 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
440 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
441
442 HS_ALL_PROGS = \
443         $(HS_PROGS) \
444         test/hs/hpc-htools \
445         test/hs/hpc-mon-collector \
446         test/hs/htest \
447         $(HS_COMPILE_PROGS)
448
449 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
450 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
451
452 HFLAGS = \
453         -O -Wall -Werror -isrc \
454         -fwarn-monomorphism-restriction \
455         -fwarn-tabs \
456         $(GHC_BYVERSION_FLAGS)
457
458 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
459 HEXTRA =
460 # internal extra flags (used for test/hs/htest mainly)
461 HEXTRA_INT =
462 # exclude options for coverage reports
463 HPCEXCL = --exclude Main \
464         --exclude Ganeti.Constants \
465         --exclude Ganeti.HTools.QC \
466         --exclude Ganeti.THH \
467         --exclude Ganeti.Version \
468         --exclude Test.Ganeti.Attoparsec \
469         --exclude Test.Ganeti.TestCommon \
470         --exclude Test.Ganeti.TestHTools \
471         --exclude Test.Ganeti.TestHelper \
472         --exclude Test.Ganeti.TestImports \
473         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
474
475 HS_LIB_SRCS = \
476         src/Ganeti/Block/Drbd/Types.hs \
477         src/Ganeti/Block/Drbd/Parser.hs \
478         src/Ganeti/BasicTypes.hs \
479         src/Ganeti/Common.hs \
480         src/Ganeti/Compat.hs \
481         src/Ganeti/Confd/Client.hs \
482         src/Ganeti/Confd/Server.hs \
483         src/Ganeti/Confd/Types.hs \
484         src/Ganeti/Confd/Utils.hs \
485         src/Ganeti/Config.hs \
486         src/Ganeti/Daemon.hs \
487         src/Ganeti/DataCollectors/CLI.hs \
488         src/Ganeti/DataCollectors/Drbd.hs \
489         src/Ganeti/DataCollectors/Program.hs \
490         src/Ganeti/DataCollectors/Types.hs \
491         src/Ganeti/Errors.hs \
492         src/Ganeti/HTools/Backend/IAlloc.hs \
493         src/Ganeti/HTools/Backend/Luxi.hs \
494         src/Ganeti/HTools/Backend/Rapi.hs \
495         src/Ganeti/HTools/Backend/Simu.hs \
496         src/Ganeti/HTools/Backend/Text.hs \
497         src/Ganeti/HTools/CLI.hs \
498         src/Ganeti/HTools/Cluster.hs \
499         src/Ganeti/HTools/Container.hs \
500         src/Ganeti/HTools/ExtLoader.hs \
501         src/Ganeti/HTools/Graph.hs \
502         src/Ganeti/HTools/Group.hs \
503         src/Ganeti/HTools/Instance.hs \
504         src/Ganeti/HTools/Loader.hs \
505         src/Ganeti/HTools/Node.hs \
506         src/Ganeti/HTools/PeerMap.hs \
507         src/Ganeti/HTools/Program/Hail.hs \
508         src/Ganeti/HTools/Program/Harep.hs \
509         src/Ganeti/HTools/Program/Hbal.hs \
510         src/Ganeti/HTools/Program/Hcheck.hs \
511         src/Ganeti/HTools/Program/Hinfo.hs \
512         src/Ganeti/HTools/Program/Hscan.hs \
513         src/Ganeti/HTools/Program/Hspace.hs \
514         src/Ganeti/HTools/Program/Hroller.hs \
515         src/Ganeti/HTools/Program/Main.hs \
516         src/Ganeti/HTools/Types.hs \
517         src/Ganeti/Hash.hs \
518         src/Ganeti/JQueue.hs \
519         src/Ganeti/JSON.hs \
520         src/Ganeti/Jobs.hs \
521         src/Ganeti/Logging.hs \
522         src/Ganeti/Luxi.hs \
523         src/Ganeti/Network.hs \
524         src/Ganeti/Objects.hs \
525         src/Ganeti/OpCodes.hs \
526         src/Ganeti/OpParams.hs \
527         src/Ganeti/Path.hs \
528         src/Ganeti/Query/Common.hs \
529         src/Ganeti/Query/Filter.hs \
530         src/Ganeti/Query/Group.hs \
531         src/Ganeti/Query/Job.hs \
532         src/Ganeti/Query/Language.hs \
533         src/Ganeti/Query/Network.hs \
534         src/Ganeti/Query/Node.hs \
535         src/Ganeti/Query/Query.hs \
536         src/Ganeti/Query/Server.hs \
537         src/Ganeti/Query/Types.hs \
538         src/Ganeti/Rpc.hs \
539         src/Ganeti/Runtime.hs \
540         src/Ganeti/Ssconf.hs \
541         src/Ganeti/THH.hs \
542         src/Ganeti/Types.hs \
543         src/Ganeti/Utils.hs
544
545 HS_TEST_SRCS = \
546         test/hs/Test/Ganeti/Attoparsec.hs \
547         test/hs/Test/Ganeti/BasicTypes.hs \
548         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
549         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
550         test/hs/Test/Ganeti/Common.hs \
551         test/hs/Test/Ganeti/Confd/Types.hs \
552         test/hs/Test/Ganeti/Confd/Utils.hs \
553         test/hs/Test/Ganeti/Daemon.hs \
554         test/hs/Test/Ganeti/Errors.hs \
555         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
556         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
557         test/hs/Test/Ganeti/HTools/CLI.hs \
558         test/hs/Test/Ganeti/HTools/Cluster.hs \
559         test/hs/Test/Ganeti/HTools/Container.hs \
560         test/hs/Test/Ganeti/HTools/Graph.hs \
561         test/hs/Test/Ganeti/HTools/Instance.hs \
562         test/hs/Test/Ganeti/HTools/Loader.hs \
563         test/hs/Test/Ganeti/HTools/Node.hs \
564         test/hs/Test/Ganeti/HTools/PeerMap.hs \
565         test/hs/Test/Ganeti/HTools/Types.hs \
566         test/hs/Test/Ganeti/JSON.hs \
567         test/hs/Test/Ganeti/Jobs.hs \
568         test/hs/Test/Ganeti/JQueue.hs \
569         test/hs/Test/Ganeti/Luxi.hs \
570         test/hs/Test/Ganeti/Network.hs \
571         test/hs/Test/Ganeti/Objects.hs \
572         test/hs/Test/Ganeti/OpCodes.hs \
573         test/hs/Test/Ganeti/Query/Filter.hs \
574         test/hs/Test/Ganeti/Query/Language.hs \
575         test/hs/Test/Ganeti/Query/Query.hs \
576         test/hs/Test/Ganeti/Rpc.hs \
577         test/hs/Test/Ganeti/Runtime.hs \
578         test/hs/Test/Ganeti/Ssconf.hs \
579         test/hs/Test/Ganeti/THH.hs \
580         test/hs/Test/Ganeti/TestCommon.hs \
581         test/hs/Test/Ganeti/TestHTools.hs \
582         test/hs/Test/Ganeti/TestHelper.hs \
583         test/hs/Test/Ganeti/Types.hs \
584         test/hs/Test/Ganeti/Utils.hs
585
586 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
587
588 HS_BUILT_SRCS = \
589         test/hs/Test/Ganeti/TestImports.hs \
590         src/Ganeti/Constants.hs \
591         src/Ganeti/Version.hs
592 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
593
594 $(RUN_IN_TEMPDIR): | stamp-directories
595
596 doc/html/index.html: ENABLE_MANPAGES =
597 doc/man-html/index.html: ENABLE_MANPAGES = 1
598 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
599
600 # Note: we use here an order-only prerequisite, as the contents of
601 # _autoconf.py are not actually influencing the html build output: it
602 # has to exist in order for the sphinx module to be loaded
603 # successfully, but we certainly don't want the docs to be rebuilt if
604 # it changes
605 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
606         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
607         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
608         doc/css/style.css \
609         | $(BUILT_PYTHON_SOURCES)
610         @test -n "$(SPHINX)" || \
611             { echo 'sphinx-build' not found during configure; exit 1; }
612 if !MANPAGES_IN_DOC
613         if test -n '$(ENABLE_MANPAGES)'; then \
614           echo 'Man pages in documentation were disabled at configure time' >&2; \
615           exit 1; \
616         fi
617 endif
618 ## Sphinx provides little control over what content should be included. Some
619 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
620 ## build two different versions of the documentation--once without man pages and
621 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
622 ## us with this, but requires running in a temporary directory. It moves the
623 ## correct files into place depending on environment variables.
624         dir=$(dir $@) && \
625         @mkdir_p@ $$dir && \
626         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
627         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
628             -d . \
629             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
630             -D release="$(PACKAGE_VERSION)" \
631             -D graphviz_dot="$(DOT)" \
632             -D enable_manpages="$(ENABLE_MANPAGES)" \
633             doc $(CURDIR)/$$dir && \
634         rm -f $$dir/.buildinfo $$dir/objects.inv
635         touch $@
636
637 doc/html: doc/html/index.html
638
639 doc/man-html: doc/man-html/index.html
640
641 doc/install-quick.rst: INSTALL
642 doc/news.rst: NEWS
643 doc/upgrade.rst: UPGRADE
644
645 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
646         set -e; \
647         { echo '.. This file is automatically updated at build time from $<.'; \
648           echo '.. Do not edit.'; \
649           echo; \
650           cat $<; \
651         } > $@
652
653 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
654         { echo '.. This file is automatically generated, do not edit!'; \
655           echo ''; \
656           echo 'Man pages'; \
657           echo '========='; \
658           echo; \
659           echo '.. toctree::'; \
660           echo '   :maxdepth: 1'; \
661           echo; \
662           for i in $(notdir $(mandocrst)); do \
663             echo "   $$i"; \
664           done | LC_ALL=C sort; \
665         } > $@
666
667 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
668 if MANPAGES_IN_DOC
669         { echo '.. This file is automatically updated at build time from $<.'; \
670           echo '.. Do not edit.'; \
671           echo; \
672           echo "$*"; \
673           echo '=========================================='; \
674           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
675         } > $@
676 else
677         echo 'Man pages in documentation were disabled at configure time' >&2; \
678         exit 1;
679 endif
680
681 # Things to build but not to install (add it to EXTRA_DIST if it should be
682 # distributed)
683 noinst_DATA = \
684         doc/html \
685         $(BUILT_EXAMPLES) \
686         doc/examples/bash_completion \
687         doc/examples/bash_completion-debug \
688         $(manhtml)
689
690 if MANPAGES_IN_DOC
691 noinst_DATA += doc/man-html
692 endif
693
694 gnt_scripts = \
695         scripts/gnt-backup \
696         scripts/gnt-cluster \
697         scripts/gnt-debug \
698         scripts/gnt-group \
699         scripts/gnt-instance \
700         scripts/gnt-job \
701         scripts/gnt-network \
702         scripts/gnt-node \
703         scripts/gnt-os \
704         scripts/gnt-storage
705
706 PYTHON_BOOTSTRAP_SBIN = \
707         daemons/ganeti-masterd \
708         daemons/ganeti-noded \
709         daemons/ganeti-rapi \
710         daemons/ganeti-watcher \
711         $(gnt_scripts)
712
713 PYTHON_BOOTSTRAP = \
714         $(PYTHON_BOOTSTRAP_SBIN) \
715         tools/burnin \
716         tools/ensure-dirs \
717         tools/node-cleanup \
718         tools/node-daemon-setup \
719         tools/prepare-node-join
720
721 qa_scripts = \
722         qa/__init__.py \
723         qa/ganeti-qa.py \
724         qa/qa_cluster.py \
725         qa/qa_config.py \
726         qa/qa_daemon.py \
727         qa/qa_env.py \
728         qa/qa_error.py \
729         qa/qa_group.py \
730         qa/qa_instance.py \
731         qa/qa_job.py \
732         qa/qa_node.py \
733         qa/qa_os.py \
734         qa/qa_rapi.py \
735         qa/qa_tags.py \
736         qa/qa_utils.py
737
738 bin_SCRIPTS =
739 if WANT_HTOOLS
740 bin_SCRIPTS += $(HS_BIN_PROGS)
741 install-exec-hook:
742         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
743 # FIXME: this is a hardcoded logic, instead of auto-resolving
744         $(LN_S) -f ../../../bin/htools \
745           $(DESTDIR)$(iallocatorsdir)/hail
746         for role in $(HS_BIN_ROLES); do \
747           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
748         done
749 endif
750
751 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
752         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
753           echo "Error: cannot run unittests without the development" \
754                " libraries (see devnotes.rst)" 1>&2; \
755           exit 1; \
756         fi
757         @rm -f $(notdir $@).tix
758         $(GHC) --make \
759           $(HFLAGS) \
760           $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
761           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
762           $(HEXTRA) $(HEXTRA_INT) $@
763         @touch "$@"
764
765 # for the test/hs/htest binary, we need to enable profiling/coverage
766 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
767
768 # we compile the hpc-htools binary with the program coverage
769 test/hs/hpc-htools: HEXTRA_INT=-fhpc
770
771 # we compile the hpc-mon-collector binary with the program coverage
772 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
773
774 # test dependency
775 test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
776
777 # rules for building profiling-enabled versions of the haskell
778 # programs: hs-prof does the full two-step build, whereas
779 # hs-prof-quick does only the final rebuild (hs-prof must have been
780 # run before)
781 .PHONY: hs-prof hs-prof-quick
782 hs-prof:
783         @if [ -z "$(TARGET)" ]; then \
784           echo "You need to define TARGET when running this rule" 1>&2; \
785           exit 1; \
786         fi
787         $(MAKE) $(AM_MAKEFLAGS) clean
788         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
789         rm -f $(HS_ALL_PROGS)
790         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
791
792 hs-prof-quick:
793         @if [ -z "$(TARGET)" ]; then \
794           echo "You need to define TARGET when running this rule" 1>&2; \
795           exit 1; \
796         fi
797         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
798
799 dist_sbin_SCRIPTS = \
800         tools/ganeti-listrunner
801
802 nodist_sbin_SCRIPTS = \
803         $(PYTHON_BOOTSTRAP_SBIN) \
804         daemons/ganeti-cleaner
805
806 if ENABLE_CONFD
807 src/ganeti-confd: src/hconfd
808         cp -f $< $@
809
810 nodist_sbin_SCRIPTS += src/ganeti-confd
811 endif
812
813 python_scripts = \
814         tools/cfgshell \
815         tools/cfgupgrade \
816         tools/cfgupgrade12 \
817         tools/cluster-merge \
818         tools/confd-client \
819         tools/fmtjson \
820         tools/lvmstrap \
821         tools/move-instance \
822         tools/ovfconverter \
823         tools/sanitize-config
824
825 dist_tools_SCRIPTS = \
826         $(python_scripts) \
827         tools/kvm-console-wrapper \
828         tools/master-ip-setup \
829         tools/xen-console-wrapper
830
831 nodist_tools_python_scripts = \
832         tools/node-cleanup
833
834 nodist_tools_SCRIPTS = \
835         $(nodist_tools_python_scripts) \
836         tools/vcluster-setup
837
838 pkglib_python_scripts = \
839         daemons/import-export \
840         tools/check-cert-expired
841
842 nodist_pkglib_python_scripts = \
843         tools/burnin \
844         tools/ensure-dirs \
845         tools/node-daemon-setup \
846         tools/prepare-node-join
847
848 myexeclib_SCRIPTS = \
849         daemons/daemon-util \
850         tools/kvm-ifup \
851         $(pkglib_python_scripts) \
852         $(HS_MYEXECLIB_PROGS)
853
854 nodist_myexeclib_SCRIPTS = \
855         $(nodist_pkglib_python_scripts)
856
857 EXTRA_DIST = \
858         NEWS \
859         UPGRADE \
860         epydoc.conf.in \
861         pylintrc \
862         autotools/build-bash-completion \
863         autotools/build-rpc \
864         autotools/check-header \
865         autotools/check-imports \
866         autotools/check-man-dashes \
867         autotools/check-man-references \
868         autotools/check-man-warnings \
869         autotools/check-news \
870         autotools/check-python-code \
871         autotools/check-tar \
872         autotools/check-version \
873         autotools/convert-constants \
874         autotools/docpp \
875         autotools/gen-py-coverage \
876         autotools/sphinx-wrapper \
877         autotools/testrunner \
878         autotools/wrong-hardcoded-paths \
879         $(RUN_IN_TEMPDIR) \
880         daemons/daemon-util.in \
881         daemons/ganeti-cleaner.in \
882         $(pkglib_python_scripts) \
883         devel/upload \
884         devel/webserver \
885         tools/kvm-ifup.in \
886         tools/vcluster-setup.in \
887         $(docinput) \
888         doc/html \
889         $(BUILT_EXAMPLES:%=%.in) \
890         doc/examples/ganeti.default \
891         doc/examples/ganeti.default-debug \
892         doc/examples/hooks/ethers \
893         doc/examples/gnt-debug/README \
894         doc/examples/gnt-debug/delay0.json \
895         doc/examples/gnt-debug/delay50.json \
896         test/py/lockperf.py \
897         test/py/testutils.py \
898         test/py/mocks.py \
899         $(dist_TESTS) \
900         $(TEST_FILES) \
901         man/footer.rst \
902         $(manrst) \
903         $(maninput) \
904         qa/qa-sample.json \
905         $(qa_scripts) \
906         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
907         $(HS_PROG_SRCS) \
908         src/lint-hints.hs \
909         test/hs/cli-tests-defs.sh \
910         test/hs/offline-test.sh \
911         .ghci
912
913 man_MANS = \
914         man/ganeti-cleaner.8 \
915         man/ganeti-confd.8 \
916         man/ganeti-listrunner.8 \
917         man/ganeti-masterd.8 \
918         man/ganeti-noded.8 \
919         man/ganeti-os-interface.7 \
920         man/ganeti-extstorage-interface.7 \
921         man/ganeti-rapi.8 \
922         man/ganeti-watcher.8 \
923         man/ganeti.7 \
924         man/gnt-backup.8 \
925         man/gnt-cluster.8 \
926         man/gnt-debug.8 \
927         man/gnt-group.8 \
928         man/gnt-network.8 \
929         man/gnt-instance.8 \
930         man/gnt-job.8 \
931         man/gnt-node.8 \
932         man/gnt-os.8 \
933         man/gnt-storage.8 \
934         man/hail.1 \
935         man/hbal.1 \
936         man/hcheck.1 \
937         man/hinfo.1 \
938         man/hscan.1 \
939         man/hspace.1 \
940         man/hroller.1 \
941         man/htools.1 \
942         man/mon-collector.7
943
944 # Remove extensions from all filenames in man_MANS
945 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
946
947 manrst = $(patsubst %,%.rst,$(mannoext))
948 manhtml = $(patsubst %.rst,%.html,$(manrst))
949 mangen = $(patsubst %.rst,%.gen,$(manrst))
950 maninput = \
951         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
952         $(patsubst %.html,%.html.in,$(manhtml)) \
953         $(mangen)
954
955 TEST_FILES = \
956         test/data/htools/clean-nonzero-score.data \
957         test/data/htools/common-suffix.data \
958         test/data/htools/empty-cluster.data \
959         test/data/htools/hail-alloc-drbd.json \
960         test/data/htools/hail-change-group.json \
961         test/data/htools/hail-invalid-reloc.json \
962         test/data/htools/hail-node-evac.json \
963         test/data/htools/hail-reloc-drbd.json \
964         test/data/htools/hbal-excl-tags.data \
965         test/data/htools/hbal-split-insts.data \
966         test/data/htools/invalid-node.data \
967         test/data/htools/missing-resources.data \
968         test/data/htools/n1-failure.data \
969         test/data/htools/rapi/groups.json \
970         test/data/htools/rapi/info.json \
971         test/data/htools/rapi/instances.json \
972         test/data/htools/rapi/nodes.json \
973         test/hs/shelltests/htools-balancing.test \
974         test/hs/shelltests/htools-basic.test \
975         test/hs/shelltests/htools-dynutil.test \
976         test/hs/shelltests/htools-excl.test \
977         test/hs/shelltests/htools-hail.test \
978         test/hs/shelltests/htools-hspace.test \
979         test/hs/shelltests/htools-invalid.test \
980         test/hs/shelltests/htools-multi-group.test \
981         test/hs/shelltests/htools-no-backend.test \
982         test/hs/shelltests/htools-rapi.test \
983         test/hs/shelltests/htools-single-group.test \
984         test/hs/shelltests/htools-text-backend.test \
985         test/hs/shelltests/htools-mon-collector.test \
986         test/data/bdev-drbd-8.0.txt \
987         test/data/bdev-drbd-8.3.txt \
988         test/data/bdev-drbd-disk.txt \
989         test/data/bdev-drbd-net-ip4.txt \
990         test/data/bdev-drbd-net-ip6.txt \
991         test/data/cert1.pem \
992         test/data/cert2.pem \
993         test/data/instance-minor-pairing.txt \
994         test/data/ip-addr-show-dummy0.txt \
995         test/data/ip-addr-show-lo-ipv4.txt \
996         test/data/ip-addr-show-lo-ipv6.txt \
997         test/data/ip-addr-show-lo-oneline-ipv4.txt \
998         test/data/ip-addr-show-lo-oneline-ipv6.txt \
999         test/data/ip-addr-show-lo-oneline.txt \
1000         test/data/ip-addr-show-lo.txt \
1001         test/data/kvm_0.12.5_help.txt \
1002         test/data/kvm_0.15.90_help.txt \
1003         test/data/kvm_0.9.1_help.txt \
1004         test/data/kvm_0.9.1_help_boot_test.txt \
1005         test/data/kvm_1.0_help.txt \
1006         test/data/kvm_1.1.2_help.txt \
1007         test/data/ovfdata/compr_disk.vmdk.gz \
1008         test/data/ovfdata/config.ini \
1009         test/data/ovfdata/corrupted_resources.ovf \
1010         test/data/ovfdata/empty.ini \
1011         test/data/ovfdata/empty.ovf \
1012         test/data/ovfdata/ganeti.mf \
1013         test/data/ovfdata/ganeti.ovf \
1014         test/data/ovfdata/gzip_disk.ovf \
1015         test/data/ovfdata/new_disk.vmdk \
1016         test/data/ovfdata/no_disk.ini \
1017         test/data/ovfdata/no_disk_in_ref.ovf \
1018         test/data/ovfdata/no_os.ini \
1019         test/data/ovfdata/no_ovf.ova \
1020         test/data/ovfdata/other/rawdisk.raw \
1021         test/data/ovfdata/ova.ova \
1022         test/data/ovfdata/rawdisk.raw \
1023         test/data/ovfdata/second_disk.vmdk \
1024         test/data/ovfdata/unsafe_path.ini \
1025         test/data/ovfdata/virtualbox.ovf \
1026         test/data/ovfdata/wrong_config.ini \
1027         test/data/ovfdata/wrong_extension.ovd \
1028         test/data/ovfdata/wrong_manifest.mf \
1029         test/data/ovfdata/wrong_manifest.ovf \
1030         test/data/ovfdata/wrong_ova.ova \
1031         test/data/ovfdata/wrong_xml.ovf \
1032         test/data/proc_drbd8.txt \
1033         test/data/proc_drbd80-emptyline.txt \
1034         test/data/proc_drbd83.txt \
1035         test/data/proc_drbd83_sync.txt \
1036         test/data/proc_drbd83_sync_want.txt \
1037         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1038         test/data/qa-minimal-nodes-instances-only.json \
1039         test/data/sys_drbd_usermode_helper.txt \
1040         test/data/vgreduce-removemissing-2.02.02.txt \
1041         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1042         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1043         test/data/vgs-missing-pvs-2.02.02.txt \
1044         test/data/vgs-missing-pvs-2.02.66.txt \
1045         test/data/xen-xm-info-4.0.1.txt \
1046         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1047         test/data/xen-xm-list-4.0.1-four-instances.txt \
1048         test/py/ganeti-cli.test \
1049         test/py/gnt-cli.test \
1050         test/py/import-export_unittest-helper
1051
1052 python_tests = \
1053         doc/examples/rapi_testutils.py \
1054         test/py/cfgupgrade_unittest.py \
1055         test/py/docs_unittest.py \
1056         test/py/ganeti.asyncnotifier_unittest.py \
1057         test/py/ganeti.backend_unittest-runasroot.py \
1058         test/py/ganeti.backend_unittest.py \
1059         test/py/ganeti.bdev_unittest.py \
1060         test/py/ganeti.cli_unittest.py \
1061         test/py/ganeti.client.gnt_cluster_unittest.py \
1062         test/py/ganeti.client.gnt_instance_unittest.py \
1063         test/py/ganeti.client.gnt_job_unittest.py \
1064         test/py/ganeti.cmdlib_unittest.py \
1065         test/py/ganeti.compat_unittest.py \
1066         test/py/ganeti.confd.client_unittest.py \
1067         test/py/ganeti.config_unittest.py \
1068         test/py/ganeti.constants_unittest.py \
1069         test/py/ganeti.daemon_unittest.py \
1070         test/py/ganeti.errors_unittest.py \
1071         test/py/ganeti.hooks_unittest.py \
1072         test/py/ganeti.ht_unittest.py \
1073         test/py/ganeti.http_unittest.py \
1074         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1075         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1076         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1077         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1078         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1079         test/py/ganeti.hypervisor_unittest.py \
1080         test/py/ganeti.impexpd_unittest.py \
1081         test/py/ganeti.jqueue_unittest.py \
1082         test/py/ganeti.jstore_unittest.py \
1083         test/py/ganeti.locking_unittest.py \
1084         test/py/ganeti.luxi_unittest.py \
1085         test/py/ganeti.masterd.iallocator_unittest.py \
1086         test/py/ganeti.masterd.instance_unittest.py \
1087         test/py/ganeti.mcpu_unittest.py \
1088         test/py/ganeti.netutils_unittest.py \
1089         test/py/ganeti.objects_unittest.py \
1090         test/py/ganeti.objectutils_unittest.py \
1091         test/py/ganeti.opcodes_unittest.py \
1092         test/py/ganeti.ovf_unittest.py \
1093         test/py/ganeti.qlang_unittest.py \
1094         test/py/ganeti.query_unittest.py \
1095         test/py/ganeti.rapi.baserlib_unittest.py \
1096         test/py/ganeti.rapi.client_unittest.py \
1097         test/py/ganeti.rapi.resources_unittest.py \
1098         test/py/ganeti.rapi.rlib2_unittest.py \
1099         test/py/ganeti.rapi.testutils_unittest.py \
1100         test/py/ganeti.rpc_unittest.py \
1101         test/py/ganeti.runtime_unittest.py \
1102         test/py/ganeti.serializer_unittest.py \
1103         test/py/ganeti.server.rapi_unittest.py \
1104         test/py/ganeti.ssconf_unittest.py \
1105         test/py/ganeti.ssh_unittest.py \
1106         test/py/ganeti.storage_unittest.py \
1107         test/py/ganeti.tools.burnin_unittest.py \
1108         test/py/ganeti.tools.ensure_dirs_unittest.py \
1109         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1110         test/py/ganeti.tools.prepare_node_join_unittest.py \
1111         test/py/ganeti.uidpool_unittest.py \
1112         test/py/ganeti.utils.algo_unittest.py \
1113         test/py/ganeti.utils.filelock_unittest.py \
1114         test/py/ganeti.utils.hash_unittest.py \
1115         test/py/ganeti.utils.io_unittest-runasroot.py \
1116         test/py/ganeti.utils.io_unittest.py \
1117         test/py/ganeti.utils.log_unittest.py \
1118         test/py/ganeti.utils.lvm_unittest.py \
1119         test/py/ganeti.utils.mlock_unittest.py \
1120         test/py/ganeti.utils.nodesetup_unittest.py \
1121         test/py/ganeti.utils.process_unittest.py \
1122         test/py/ganeti.utils.retry_unittest.py \
1123         test/py/ganeti.utils.text_unittest.py \
1124         test/py/ganeti.utils.wrapper_unittest.py \
1125         test/py/ganeti.utils.x509_unittest.py \
1126         test/py/ganeti.utils_unittest.py \
1127         test/py/ganeti.vcluster_unittest.py \
1128         test/py/ganeti.workerpool_unittest.py \
1129         test/py/pycurl_reset_unittest.py \
1130         test/py/qa.qa_config_unittest.py \
1131         test/py/tempfile_fork_unittest.py
1132
1133 haskell_tests = test/hs/htest
1134
1135 dist_TESTS = \
1136         test/py/check-cert-expired_unittest.bash \
1137         test/py/daemon-util_unittest.bash \
1138         test/py/ganeti-cleaner_unittest.bash \
1139         test/py/import-export_unittest.bash \
1140         test/py/cli-test.bash \
1141         test/py/bash_completion.bash \
1142         $(python_tests)
1143
1144 nodist_TESTS =
1145 check_SCRIPTS =
1146
1147 if WANT_HSTESTS
1148 nodist_TESTS += $(haskell_tests)
1149 dist_TESTS += test/hs/offline-test.sh
1150 check_SCRIPTS += \
1151         test/hs/hpc-htools \
1152         test/hs/hpc-mon-collector \
1153         $(HS_BUILT_TEST_HELPERS)
1154 endif
1155
1156 TESTS = $(dist_TESTS) $(nodist_TESTS)
1157
1158 # Environment for all tests
1159 PLAIN_TESTS_ENVIRONMENT = \
1160         PYTHONPATH=. \
1161         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1162         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1163         $(RUN_IN_TEMPDIR)
1164
1165 # Environment for tests run by automake
1166 TESTS_ENVIRONMENT = \
1167         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1168
1169 all_python_code = \
1170         $(dist_sbin_SCRIPTS) \
1171         $(python_scripts) \
1172         $(pkglib_python_scripts) \
1173         $(nodist_pkglib_python_scripts) \
1174         $(nodist_tools_python_scripts) \
1175         $(python_tests) \
1176         $(pkgpython_PYTHON) \
1177         $(client_PYTHON) \
1178         $(hypervisor_PYTHON) \
1179         $(rapi_PYTHON) \
1180         $(server_PYTHON) \
1181         $(pytools_PYTHON) \
1182         $(http_PYTHON) \
1183         $(confd_PYTHON) \
1184         $(masterd_PYTHON) \
1185         $(impexpd_PYTHON) \
1186         $(utils_PYTHON) \
1187         $(watcher_PYTHON) \
1188         $(noinst_PYTHON) \
1189         $(qa_scripts)
1190
1191 srclink_files = \
1192         man/footer.rst \
1193         test/py/check-cert-expired_unittest.bash \
1194         test/py/daemon-util_unittest.bash \
1195         test/py/ganeti-cleaner_unittest.bash \
1196         test/py/import-export_unittest.bash \
1197         test/py/cli-test.bash \
1198         test/py/bash_completion.bash \
1199         test/hs/offline-test.sh \
1200         test/hs/cli-tests-defs.sh \
1201         $(all_python_code) \
1202         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1203         $(docinput)
1204
1205 check_python_code = \
1206         $(BUILD_BASH_COMPLETION) \
1207         $(CHECK_IMPORTS) \
1208         $(CHECK_HEADER) \
1209         $(DOCPP) \
1210         $(all_python_code)
1211
1212 lint_python_code = \
1213         ganeti \
1214         ganeti/http/server.py \
1215         $(dist_sbin_SCRIPTS) \
1216         $(python_scripts) \
1217         $(pkglib_python_scripts) \
1218         $(BUILD_BASH_COMPLETION) \
1219         $(CHECK_IMPORTS) \
1220         $(CHECK_HEADER) \
1221         $(DOCPP) \
1222         $(PYTHON_BOOTSTRAP)
1223
1224 standalone_python_modules = \
1225         lib/rapi/client.py \
1226         tools/ganeti-listrunner
1227
1228 pep8_python_code = \
1229         ganeti \
1230         ganeti/http/server.py \
1231         $(dist_sbin_SCRIPTS) \
1232         $(python_scripts) \
1233         $(pkglib_python_scripts) \
1234         $(BUILD_BASH_COMPLETION) \
1235         $(CHECK_HEADER) \
1236         $(DOCPP) \
1237         $(PYTHON_BOOTSTRAP) \
1238         qa
1239
1240 test/py/daemon-util_unittest.bash: daemons/daemon-util
1241
1242 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1243
1244 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1245
1246 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1247         sed -f $(REPLACE_VARS_SED) < $< > $@
1248         chmod +x $@
1249
1250 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1251         sed -f $(REPLACE_VARS_SED) < $< > $@
1252         chmod +x $@
1253
1254 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1255         sed -f $(REPLACE_VARS_SED) < $< > $@
1256         chmod +x $@
1257
1258 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1259         sed -f $(REPLACE_VARS_SED) < $< > $@
1260
1261 doc/examples/bash_completion: BC_ARGS = --compact
1262 doc/examples/bash_completion-debug: BC_ARGS =
1263
1264 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1265         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1266         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1267         daemons/ganeti-cleaner \
1268         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1269         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1270           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1271
1272 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1273         lib/build/shell_example_lexer.py \
1274         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1275         @echo "Checking $< for hardcoded paths..."
1276         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1277           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1278           exit 1; \
1279         fi
1280         set -e ; \
1281         trap 'echo auto-removing $@; rm $@' EXIT; \
1282         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1283         $(CHECK_MAN_REFERENCES) $@; \
1284         trap - EXIT
1285
1286 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1287         @test -n "$(PANDOC)" || \
1288           { echo 'pandoc' not found during configure; exit 1; }
1289         set -o pipefail ; \
1290         trap 'echo auto-removing $@; rm $@' EXIT; \
1291         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1292           sed -e 's/\\@/@/g' > $@; \
1293         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1294         $(CHECK_MAN_DASHES) $@; \
1295         trap - EXIT
1296
1297 man/%.html.in: man/%.gen man/footer.rst
1298         @test -n "$(PANDOC)" || \
1299           { echo 'pandoc' not found during configure; exit 1; }
1300         set -o pipefail ; \
1301         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1302           sed -e 's/\\@/@/g' > $@
1303
1304 man/%: man/%.in  $(REPLACE_VARS_SED)
1305         sed -f $(REPLACE_VARS_SED) < $< > $@
1306
1307 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1308         sed -f $(REPLACE_VARS_SED) < $< > $@
1309
1310 vcs-version:
1311         if test -d .git; then \
1312           git describe > $@; \
1313         elif test ! -f $@ ; then \
1314           echo "Cannot auto-generate $@ file"; exit 1; \
1315         fi
1316
1317 .PHONY: clean-vcs-version
1318 clean-vcs-version:
1319         rm -f vcs-version
1320
1321 .PHONY: regen-vcs-version
1322 regen-vcs-version:
1323         @set -e; \
1324         cd $(srcdir); \
1325         if test -d .git; then \
1326           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1327           git describe > $$T; \
1328           if ! cmp --quiet $$T vcs-version; then \
1329             mv $$T vcs-version; \
1330           fi; \
1331         fi
1332
1333 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1334         vcs-version $(built_base_sources)
1335         set -e; \
1336         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1337         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1338
1339 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1340         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1341         lib/jstore.py $(RUN_IN_TEMPDIR) \
1342         $(CONVERT_CONSTANTS) $(built_base_sources) \
1343         | lib/_vcsversion.py
1344         set -e; \
1345         { cat $< ; \
1346           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1347         } > $@
1348
1349 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1350         $(built_base_sources)
1351         set -e; \
1352         { cat $< ; \
1353           echo ; \
1354           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1355             echo "import $$name ()" ; \
1356           done ; \
1357         } > $@
1358
1359 lib/_autoconf.py: Makefile | stamp-directories
1360         set -e; \
1361         { echo '# This file is automatically generated, do not edit!'; \
1362           echo '#'; \
1363           echo ''; \
1364           echo '"""Build-time configuration for Ganeti.'; \
1365           echo '';\
1366           echo 'This file is autogenerated by the build process.'; \
1367           echo 'For any changes you need to re-run ./configure (and'; \
1368           echo 'not edit by hand).'; \
1369           echo ''; \
1370           echo '"""'; \
1371           echo ''; \
1372           echo '# pylint: disable=C0301,C0324'; \
1373           echo '# because this is autogenerated, we do not want'; \
1374           echo '# style warnings' ; \
1375           echo ''; \
1376           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1377           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1378           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1379           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1380           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1381           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1382           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1383           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1384           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1385           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1386           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1387           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1388           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1389           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1390           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1391           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1392           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1393           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1394           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1395           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1396           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1397           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1398           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1399           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1400           echo "KVM_PATH = '$(KVM_PATH)'"; \
1401           echo "IP_PATH = '$(IP_PATH)'"; \
1402           echo "SOCAT_PATH = '$(SOCAT)'"; \
1403           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1404           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1405           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1406           echo "TOOLSDIR = '$(toolsdir)'"; \
1407           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1408           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1409           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1410           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1411           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1412           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1413           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1414           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1415           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1416           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1417           echo "RAPI_USER = '$(RAPI_USER)'"; \
1418           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1419           echo "CONFD_USER = '$(CONFD_USER)'"; \
1420           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1421           echo "NODED_USER = '$(NODED_USER)'"; \
1422           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1423           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1424           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1425           echo "HTOOLS = True"; \
1426           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1427           echo "XEN_CMD = '$(XEN_CMD)'"; \
1428           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1429           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1430           echo "ENABLE_MONITORING = $(ENABLE_MONITORING)"; \
1431 ## Write dictionary with man page name as the key and the section number as the
1432 ## value
1433           echo "MAN_PAGES = {"; \
1434           for i in $(notdir $(man_MANS)); do \
1435             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1436           done; \
1437           echo "}"; \
1438         } > $@
1439
1440 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1441         set -e; \
1442         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1443         { echo '# This file is automatically generated, do not edit!'; \
1444           echo '#'; \
1445           echo ''; \
1446           echo '"""Build-time VCS version number for Ganeti.'; \
1447           echo '';\
1448           echo 'This file is autogenerated by the build process.'; \
1449           echo 'For any changes you need to re-run ./configure (and'; \
1450           echo 'not edit by hand).'; \
1451           echo ''; \
1452           echo '"""'; \
1453           echo ''; \
1454           echo '# pylint: disable=C0301,C0324'; \
1455           echo '# because this is autogenerated, we do not want'; \
1456           echo '# style warnings' ; \
1457           echo ''; \
1458           echo "VCS_VERSION = '$$VCSVER'"; \
1459         } > $@
1460
1461 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1462         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1463
1464 $(SHELL_ENV_INIT): Makefile stamp-directories
1465         set -e; \
1466         { echo '# Allow overriding for tests'; \
1467           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1468           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1469           echo; \
1470           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1471           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1472           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1473           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1474           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1475         } > $@
1476
1477 ## Writes sed script to replace placeholders with build-time values. The
1478 ## additional quotes after the first @ sign are necessary to stop configure
1479 ## from replacing those values as well.
1480 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1481         set -e; \
1482         { echo 's#@''PREFIX@#$(prefix)#g'; \
1483           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1484           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1485           echo 's#@''BINDIR@#$(bindir)#g'; \
1486           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1487           echo 's#@''LIBDIR@#$(libdir)#g'; \
1488           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1489           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1490           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1491           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1492           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1493           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1494           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1495           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1496           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1497           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1498           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1499           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1500           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1501           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1502           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1503           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1504           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1505           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1506           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1507           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1508           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1509           echo; \
1510           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1511           echo '  r $(SHELL_ENV_INIT)'; \
1512           echo '  d'; \
1513           echo '}'; \
1514         } > $@
1515
1516 # Using deferred evaluation
1517 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1518 daemons/ganeti-watcher: MODULE = ganeti.watcher
1519 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1520 tools/burnin: MODULE = ganeti.tools.burnin
1521 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1522 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1523 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1524 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1525 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1526
1527 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1528         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1529         set -e; \
1530         { echo '#!/usr/bin/python'; \
1531           echo '# This file is automatically generated, do not edit!'; \
1532           echo "# Edit $(MODULE) instead."; \
1533           echo; \
1534           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1535           echo; \
1536           echo '# pylint: disable=C0103'; \
1537           echo '# C0103: Invalid name'; \
1538           echo; \
1539           echo 'import sys'; \
1540           echo 'import $(MODULE) as main'; \
1541           echo; \
1542           echo '# Temporarily alias commands until bash completion'; \
1543           echo '# generator is changed'; \
1544           echo 'if hasattr(main, "commands"):'; \
1545           echo '  commands = main.commands # pylint: disable=E1101'; \
1546           echo 'if hasattr(main, "aliases"):'; \
1547           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1548           echo; \
1549           echo 'if __name__ == "__main__":'; \
1550           echo '  sys.exit(main.Main())'; \
1551         } > $@
1552         chmod u+x $@
1553
1554 $(HS_BUILT_TEST_HELPERS): Makefile
1555         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1556         set -e; \
1557         { echo '#!/bin/sh'; \
1558           echo '# This file is automatically generated, do not edit!'; \
1559           echo "# Edit Makefile.am instead."; \
1560           echo; \
1561           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1562         } > $@
1563         chmod u+x $@
1564
1565 stamp-directories: Makefile
1566         $(MAKE) $(AM_MAKEFLAGS) ganeti
1567         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1568         touch $@
1569
1570 # We need to create symlinks because "make distcheck" will not install Python
1571 # files when building.
1572 stamp-srclinks: Makefile | stamp-directories
1573         set -e; \
1574         for i in $(srclink_files); do \
1575           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1576             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1577           fi; \
1578         done
1579         touch $@
1580
1581 .PHONY: ganeti
1582 ganeti:
1583         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1584
1585 .PHONY: check-dirs
1586 check-dirs: $(GENERATED_FILES)
1587         @set -e; \
1588         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1589           error=; \
1590           while read dir; do \
1591             case "$$dir" in \
1592               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1593               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1594             esac; \
1595           done; \
1596           for dir in $(DIRS); do \
1597             if ! test -d "$$dir"; then \
1598               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1599               error=1; \
1600             fi \
1601           done; \
1602           test -z "$$error"; \
1603         }
1604
1605 .PHONY: check-local
1606 check-local: check-dirs $(GENERATED_FILES)
1607         $(CHECK_PYTHON_CODE) $(check_python_code)
1608         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1609         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1610         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1611         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1612         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1613         error= ; \
1614         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1615           echo "Incorrect version in README, expected $$expver" >&2; \
1616           error=1; \
1617         fi; \
1618         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1619             doc/security.rst; do \
1620           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1621             "Documents Ganeti version $$expver"; then \
1622             echo "Incorrect version in $$file, expected $$expver" >&2; \
1623             error=1; \
1624           fi; \
1625         done; \
1626         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1627           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1628           error=1; \
1629         fi; \
1630         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1631           ".. Last updated for Ganeti $$expver"; then \
1632           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1633           error=1; \
1634         fi; \
1635         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1636           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1637             echo "Longest line in $$file is longer than 80 characters" >&2; \
1638             error=1; \
1639           fi; \
1640         done; \
1641         test -z "$$error"
1642
1643 .PHONY: hs-tests
1644 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1645         @rm -f htest.tix
1646         ./test/hs/htest
1647
1648 .PHONY: hs-shell
1649 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1650         @rm -f hpc-htools.tix hpc-mon-collector.tix
1651         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1652
1653 .PHONY: hs-check
1654 hs-check: hs-tests hs-shell
1655
1656 # E111: indentation is not a multiple of four
1657 # E121: continuation line indentation is not a multiple of four
1658 #       (since our indent level is not 4)
1659 # E125: continuation line does not distinguish itself from next logical line
1660 #       (since our indent level is not 4)
1661 # E127: continuation line over-indented for visual indent
1662 #       (since our indent level is not 4)
1663 # note: do NOT add E128 here; it's a valid style error in most cases!
1664 # I've seen real errors, but also some cases were we indent wrongly
1665 # due to line length; try to rework the cases where it is triggered,
1666 # instead of silencing it
1667 # E261: at least two spaces before inline comment
1668 # E501: line too long (80 characters)
1669 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1670
1671 # For excluding pep8 expects filenames only, not whole paths
1672 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1673
1674 LINT_TARGETS = pylint pylint-qa
1675 if HAS_PEP8
1676 LINT_TARGETS += pep8
1677 endif
1678 if HAS_HLINT
1679 LINT_TARGETS += hlint
1680 endif
1681
1682 .PHONY: lint
1683 lint: $(LINT_TARGETS)
1684
1685 .PHONY: pylint
1686 pylint: $(GENERATED_FILES)
1687         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1688         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1689
1690 .PHONY: pylint-qa
1691 pylint-qa: $(GENERATED_FILES)
1692         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1693         cd $(top_srcdir)/qa && \
1694           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1695           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1696
1697 .PHONY: pep8
1698 pep8: $(GENERATED_FILES)
1699         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1700         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1701           --repeat $(pep8_python_code)
1702
1703 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1704 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1705 .PHONY: hlint
1706 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1707         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1708         @rm -f doc/hs-lint.html
1709         if tty -s; then C="-c"; else C=""; fi; \
1710         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1711           --ignore "Use first" \
1712           --ignore "Use &&&" \
1713           --ignore "Use void" \
1714           --ignore "Reduce duplication" \
1715           --hint src/lint-hints \
1716           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1717         @if [ ! -f doc/hs-lint.html ]; then \
1718           echo "All good" > doc/hs-lint.html; \
1719         fi
1720
1721 # a dist hook rule for updating the vcs-version file; this is
1722 # hardcoded due to where it needs to build the file...
1723 dist-hook:
1724         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1725         rm -f $(top_distdir)/vcs-version
1726         cp -p $(srcdir)/vcs-version $(top_distdir)
1727
1728 # a distcheck hook rule for catching revision control directories
1729 distcheck-hook:
1730         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1731           echo "Found revision control files in final archive." 1>&2; \
1732           exit 1; \
1733         fi
1734         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1735           echo "Found Python byte code in final archive." 1>&2; \
1736           exit 1; \
1737         fi
1738         if find $(top_distdir) -name '*~' | grep .; then \
1739           echo "Found backup files in final archive." 1>&2; \
1740           exit 1; \
1741         fi
1742 # Empty files or directories should not be distributed. They can cause
1743 # unnecessary warnings for packagers. Directories used by automake during
1744 # distcheck must be excluded.
1745         if find $(top_distdir) -empty -and -not \( \
1746             -path $(top_distdir)/_build -or \
1747             -path $(top_distdir)/_inst \) | grep .; then \
1748           echo "Found empty files or directories in final archive." 1>&2; \
1749           exit 1; \
1750         fi
1751         if test -n "$(BUILD_RELEASE)" && \
1752            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1753            echo "Found unreleased version in NEWS." >&2; \
1754            exit 1; \
1755         fi
1756         if test -e $(top_distdir)/doc/man-html; then \
1757           echo "Found documentation including man pages in final archive" >&2; \
1758           exit 1; \
1759         fi
1760
1761 # When building a release, stricter checks should be used
1762 distcheck-release dist-release: export BUILD_RELEASE = 1
1763 distcheck-release: distcheck
1764
1765 distrebuildcheck: dist
1766         set -e; \
1767         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1768         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1769         cd $$builddir; \
1770         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1771         cd $(distdir); \
1772         ./configure; \
1773         $(MAKE) maintainer-clean; \
1774         cp $(abs_srcdir)/vcs-version .; \
1775         ./configure; \
1776         $(MAKE) $(AM_MAKEFLAGS)
1777
1778 dist-release: dist
1779         set -e; \
1780         for i in $(DIST_ARCHIVES); do \
1781           echo -n "Checking $$i ... "; \
1782           autotools/check-tar < $$i; \
1783           echo OK; \
1784         done
1785
1786 install-exec-local:
1787         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1788           "$(DESTDIR)${localstatedir}/log/ganeti" \
1789           "$(DESTDIR)${localstatedir}/run/ganeti"
1790
1791 .PHONY: apidoc
1792 if WANT_HSAPIDOC
1793 apidoc: py-apidoc hs-apidoc
1794 else
1795 apidoc: py-apidoc
1796 endif
1797
1798 .PHONY: py-apidoc
1799 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1800         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1801         $(RUN_IN_TEMPDIR) epydoc -v \
1802           --conf $(CURDIR)/epydoc.conf \
1803           --output $(CURDIR)/$(APIDOC_PY_DIR)
1804
1805 .PHONY: hs-apidoc
1806 hs-apidoc: $(HS_BUILT_SRCS)
1807         @test -n "$(HSCOLOUR)" || \
1808             { echo 'HsColour' not found during configure; exit 1; }
1809         @test -n "$(HADDOCK)" || \
1810             { echo 'haddock' not found during configure; exit 1; }
1811         rm -rf $(APIDOC_HS_DIR)/*
1812         for i in $(ALL_APIDOC_HS_DIRS); do \
1813           @mkdir_p@ $$i; \
1814         done
1815         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1816         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1817         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1818         set -e ; \
1819         cd src; \
1820         if [ "$(HS_NOCURL)" ]; \
1821         then OPTGHC="--optghc=$(HS_NOCURL)"; \
1822         else OPTGHC=""; \
1823         fi; \
1824         if [ "$(HS_PARALLEL3)" ]; \
1825         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1826         fi; \
1827         if [ "$(HS_REGEX_PCRE)" ]; \
1828         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1829         fi; \
1830         RELSRCS="$(HS_LIB_SRCS:src/%=%) $(patsubst src/%,%,$(filter src/%,$(HS_BUILT_SRCS)))"; \
1831         for file in $$RELSRCS; do \
1832           hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1833           $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1834         done ; \
1835         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1836           -t ganeti -p haddock-prologue \
1837           --source-module="%{MODULE/.//}.html" \
1838           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1839           $$OPTGHC \
1840           $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:src/%=%))
1841
1842 .PHONY: TAGS
1843 TAGS: $(GENERATED_FILES)
1844         rm -f TAGS
1845         $(GHC) -e ":etags" -v0 \
1846           $(filter-out -O -Werror,$(HFLAGS)) \
1847           $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1848           $(HS_LIBTEST_SRCS)
1849         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1850           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1851           -path './qa/*.py' | \
1852           etags -l python -a -
1853
1854 .PHONY: coverage
1855 if WANT_HTOOLS
1856 coverage: py-coverage hs-coverage
1857 else
1858 coverage: py-coverage
1859 endif
1860
1861 .PHONY: py-coverage
1862 py-coverage: $(GENERATED_FILES) $(python_tests)
1863         @test -n "$(PYCOVERAGE)" || \
1864             { echo 'python-coverage' not found during configure; exit 1; }
1865         set -e; \
1866         COVERAGE=$(PYCOVERAGE) \
1867         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1868         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1869         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1870         $(PLAIN_TESTS_ENVIRONMENT) \
1871         $(abs_top_srcdir)/autotools/gen-py-coverage \
1872         $(python_tests)
1873
1874 .PHONY: hs-coverage
1875 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1876         rm -f *.tix
1877         $(MAKE) $(AM_MAKEFLAGS) hs-check
1878         @mkdir_p@ $(COVERAGE_HS_DIR)
1879         hpc sum --union $(HPCEXCL) \
1880           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1881         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1882         hpc report coverage-hs.tix
1883         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1884
1885 # Special "kind-of-QA" target for htools, needs special setup (all
1886 # tools compiled with -fhpc)
1887 .PHONY: live-test
1888 live-test: all
1889         set -e ; \
1890         cd src; \
1891         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1892         rm -f *.tix *.mix; \
1893         ./live-test.sh; \
1894         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
1895           --output=live-test.tix ; \
1896         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1897         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1898           --srcdir=.. $(HPCEXCL) ; \
1899         hpc report --srcdir=.. live-test $(HPCEXCL)
1900
1901 commit-check: distcheck lint apidoc
1902
1903 .PHONY: gitignore-check
1904 gitignore-check:
1905         @if [ -n "`git status --short`" ]; then \
1906           echo "Git status is not clean!" 1>&2 ; \
1907           git status --short; \
1908           exit 1; \
1909         fi
1910
1911 # target to rebuild all man pages (both groff and html output)
1912 .PHONY: man
1913 man: $(man_MANS) $(manhtml)
1914
1915 # Target that builds all binaries (including those that are not
1916 # rebuilt except when running the tests)
1917 .PHONY: really-all
1918 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
1919
1920 # we don't need the ancient implicit rules:
1921 %: %,v
1922 %: RCS/%,v
1923 %: RCS/%
1924 %: s.%
1925 %: SCCS/s.%
1926
1927 -include ./Makefile.local
1928
1929 # vim: set noet :